import { EntityClass } from './query';
export declare class Schema {
    tables: Map<(new () => Object) | Function, Table>;
    getTable(entity: EntityClass | Function): Table;
    convertItemToObject(entity: Object): {};
    convertObjectToItem<T>(data: Object, entity: {
        new (): T;
    }, prefix: string, item?: T): T;
    dump(): void;
}
/**
 * @brief Abstract database table.
 */
export declare class Table {
    entity: Function;
    name: string;
    fields: Map<string, Field>;
    idField: Field;
    idFields: Field[];
    extends: Table;
    extendedBy: Table[];
    constructor(entity: Function);
    createField(name: string, type?: Function): Field;
    getField(name: string): Field;
    hasField(name: string): boolean;
}
/**
 * @brief Abstract database table field.
 */
export declare class Field {
    table: Table;
    name: string;
    type?: Function;
    internalName: string;
    associatedField: Field;
    isArray: boolean;
    leading: boolean;
    joinTable: string;
    constructor(table: Table, name: string, type?: Function);
    associate(field: Field): void;
}
